#include "main.h"
#include <stdlib.h>

char BotName[] = "SimpleBot v1.0 (C++)";

DLL_EXPORT LPSTR __stdcall GetName()
{
   return BotName;
}

const int Projects[MaxProjectsToPlayer] = {5, 6, 11, 13, 16, 18, 20, 28, 33, 34, 35, 44, 45, 46, 50};

DLL_EXPORT int __stdcall StartGame(int aPlayerNumber, PAvailProjects aAvailProjects, PAdditionalGameInfo AGI)
{
    srand(GetTickCount());
    if (!aAvailProjects) return 0;
    for (int i=0; i<MaxProjectsToPlayer; i++)
    {
        aAvailProjects[i]=Projects[i];
    }
    return 0;
}

int GetOtherPlayer(int aPlayer)
{
    int res=0;
    if (aPlayer==0) res=1;
    return res;
}

bool IsProjectAvail(int aProject, PAvailProjects aAvailProjects)
{
    for(int i=0; i<MaxProjectsToPlayer; i++)
    {
        if (aAvailProjects[i]==aProject) return true;
    }
    return false;
}

DLL_EXPORT int __stdcall GetTurn(int aPlayerNumber, PPlayerInfo aGame, PAvailProjects aAvailProjects, PAdditionalGameInfo AGI)
{
    if (!aAvailProjects) return 0;
    int OPP = GetOtherPlayer(aPlayerNumber);

    if ((IsProjectAvail(20,aAvailProjects)) and
       (aGame[aPlayerNumber].Base<25))
    return 20;

    if ((IsProjectAvail(18,aAvailProjects)) and
       (aGame[aPlayerNumber].Base<20))
    return 18;

    if ((IsProjectAvail(16,aAvailProjects)) and
       (aGame[aPlayerNumber].Shield<5))
    return 16;

    if (IsProjectAvail(34,aAvailProjects) and
       (aGame[aPlayerNumber].Mines<3) and
       (aGame[aPlayerNumber].Base>35) and
       (aGame[aPlayerNumber].Shield>2))
    return 34;

    if (IsProjectAvail(33,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<4) and
       (aGame[aPlayerNumber].Base>35) and
       (aGame[aPlayerNumber].Shield>2))
    return 33;

    if (IsProjectAvail(35,aAvailProjects) and
       (aGame[aPlayerNumber].Labs<3) and
       (aGame[aPlayerNumber].Base>35) and
       (aGame[aPlayerNumber].Shield>2))
    return 35;

    if (IsProjectAvail(46,aAvailProjects)) return 46;
    if (IsProjectAvail(28,aAvailProjects)) return 28;

    if (IsProjectAvail(45,aAvailProjects) and
       (aGame[OPP].Battery>3))
    return 45;

    if (IsProjectAvail(44,aAvailProjects) and
       (aGame[OPP].Mines>2))
    return 44;


    int res;
    do
    {
        res=aAvailProjects[rand()%15];
    } while (res==0);
    return res;
}


BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // attach to process
            // return FALSE to fail DLL load
            break;

        case DLL_PROCESS_DETACH:
            // detach from process
            break;

        case DLL_THREAD_ATTACH:
            // attach to thread
            break;

        case DLL_THREAD_DETACH:
            // detach from thread
            break;
    }
    return TRUE; // succesful
}
